/*
 * Sabrina Forster, Andreas Bachmann
 * Tabellen erzeugen
 */

CREATE TABLE mitglied (
  id SERIAL PRIMARY KEY,
  name VARCHAR(80) NOT NULL,
  mail VARCHAR(80) NOT NULL
  );

CREATE TABLE kampfrichter (
  id INTEGER PRIMARY KEY REFERENCES mitglied(id),
  spezialgebiet VARCHAR(80) NOT NULL
);

CREATE TABLE teilnehmer (
  id INTEGER PRIMARY KEY REFERENCES mitglied(id),
  startnummer INTEGER NOT NULL,
  meldewert INTEGER
);

CREATE TABLE wettkampf (
  id SERIAL PRIMARY KEY,
  name VARCHAR(100) NOT NULL,
  ort VARCHAR(100) NOT NULL,
  datum DATE NOT NULL
);

CREATE TABLE sportarten (
  id SERIAL PRIMARY KEY,
  name VARCHAR(80) NOT NULL
);

CREATE TABLE angebot (
  tournier INTEGER REFERENCES wettkampf(id),
  sportart INTEGER REFERENCES sportarten(id),
  PRIMARY KEY (tournier, sportart)
);

-- Typ 1= Teilnehmer, Typ 2= Kampfrichter
CREATE TABLE anmeldung (
  person INTEGER REFERENCES mitglied(id),
  tournier INTEGER REFERENCES wettkampf(id),
  typ INTEGER NOT NULL,
  kommentar VARCHAR(200),
  PRIMARY KEY (person, tournier)
);
 

